﻿using ProjectMonorail.DrawingObjects;

namespace ProjectMonorail.MovementStrategy
{
    /// <summary>
    /// Реализация интерфейса IMoveableObject для работы с объектом DrawingMonorail (паттерн Adapter)
    /// </summary>
    public class DrawingObjectMonorail : IMoveableObject
    {
        private readonly DrawingMonorail? _drawingMonorail = null;

        public DrawingObjectMonorail(DrawingMonorail drawingMonorail)
        {
            _drawingMonorail = drawingMonorail;
        }

        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawingMonorail == null || _drawingMonorail.EntityMonorail == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawingMonorail.GetPosX, _drawingMonorail.GetPosY,
                    _drawingMonorail.GetWidth, _drawingMonorail.GetHeight);
            }
        }

        public int GetStep => (int)(_drawingMonorail?.EntityMonorail?.Step ?? 0);

        public bool CheckCanMove(DirectionType direction) =>
        _drawingMonorail?.CanMove(direction) ?? false;

        public void MoveObject(DirectionType direction) =>
        _drawingMonorail?.MoveTransport(direction);
    }
}
