﻿namespace ProjectMonorail.Entities
{
    /// <summary>
    /// Класс-сущность "Расширенный монорельс"
    /// </summary>
    public class EntityExtendedMonorail : EntityMonorail
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; set; }

        /// <summary>
        /// Признак (опция) наличия магнитной рельсы
        /// </summary>
        public bool MagneticRail { get; private set; }

        /// <summary>
        /// Признак (опция) наличия дополнительной кабины
        /// </summary>
        public bool ExtraCabin { get; private set; }

        /// <summary>
        /// Инициализация полей объекта-класса расширенного монорельса
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес монорельса</param>
        /// <param name="mainColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="magneticRail">Признак наличия магнитной рельсы</param>
        /// <param name="extraCabin">Признак наличия дополнительной кабины</param>
        public EntityExtendedMonorail(int speed, double weight, Color mainColor, Color
        additionalColor, bool magneticRail, bool extraCabin) : base(speed, weight, mainColor)
        {
            AdditionalColor = additionalColor;
            MagneticRail = magneticRail;
            ExtraCabin = extraCabin;
        }
    }
}
