﻿namespace ProjectMonorail.Entities
{
    /// <summary>
    /// Класс-сущность "Монорельс"
    /// </summary>
    public class EntityMonorail
    {
        /// <summary>
        /// Скорость
        /// </summary>
        public int Speed { get; private set; }

        /// <summary>
        /// Вес
        /// </summary>
        public double Weight { get; private set; }

        /// <summary>
        /// Основной цвет
        /// </summary>
        public Color MainColor { get; set; }

        /// <summary>
        /// Шаг перемещения монорельса
        /// </summary>
        public double Step => (double)Speed * 100 / Weight;

        /// <summary>
        /// Конструктор с параметрами
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес монорельса</param>
        /// <param name="bodyColor">Основной цвет</param>
        public EntityMonorail(int speed, double weight, Color mainColor)
        {
            Speed = speed;
            Weight = weight;
            MainColor = mainColor;
        }
    }
}

